/*
 * Copyright (c) 2004, 2005 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2002-2005 Mellanox Technologies LTD. All rights reserved.
 * Copyright (c) 1996-2003 Intel Corporation. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#ifndef _CL_FCNTL_H_
#define _CL_FCNTL_H_

#include <stdio.h>
#include <complib/cl_types.h>

FILE* cl_fopen(const char *filename, const char *mode);
cl_status_t cl_fclose(FILE *stream);
cl_status_t cl_remove(const char* filename);
size_t cl_fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
size_t cl_fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
size_t cl_feof(FILE *stream);
cl_status_t cl_file_size(FILE *stream, size_t *file_size_p);
cl_status_t cl_frename(const char* old_filename, const char* new_filename);
cl_status_t cl_sync(void);
cl_status_t cl_fsync(FILE *stream);
cl_status_t cl_fflush(FILE *stream);

#endif
