/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_DEV_AUTO_H__
#define __SX_DEV_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_dev.adb file.
 * ------------------------------------------------------------------------
 */

typedef sxd_dev_id_t sx_dev_id_t;

/**
 * Primitive type - Used to note device ID
 */
typedef sx_dev_id_t sx_device_id_t;


/** Enum specific MACRO */
#define SX_GENERATE_ENUM(ENUM, STR)   ENUM,
#define SX_GENERATE_STRING(ENUM, STR) STR,

/**
 * Enumerated type - Used to note the device topology type.
 */
#define FOREACH_DEV_NODE_TYPE(F)                                     \
    F(SX_DEV_NODE_TYPE_ALL = 0,                       "ALL")         \
    F(SX_DEV_NODE_TYPE_LEAF_LOCAL,                    "LEAF_LOCAL")  \
    F(SX_DEV_NODE_TYPE_SPINE_LOCAL,                   "SPINE_LOCAL") \
    F(SX_DEV_NODE_TYPE_LEAF,                          "LEAF")        \
    F(SX_DEV_NODE_TYPE_SPINE,                         "SPINE")       \
    F(SX_DEV_NODE_TYPE_HYBRID,                        "HYBRID")      \
    F(SX_DEV_NODE_TYPE_MIN = SX_DEV_NODE_TYPE_ALL,    "")            \
    F(SX_DEV_NODE_TYPE_MAX = SX_DEV_NODE_TYPE_HYBRID, "")

typedef enum sx_dev_node_type {
    FOREACH_DEV_NODE_TYPE(SX_GENERATE_ENUM)
} sx_dev_node_type_t;


#endif /* SX_DEV_AUTO_H */
