/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_FDB_AUTO_H__
#define __SX_FDB_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_fdb.adb file.
 * ------------------------------------------------------------------------
 */

/**
 * FDB ID
 */
typedef sxd_fid_t sx_fid_t;

typedef sx_fid_t sx_fdb_id_t;


/** Enum specific MACRO */
#define SX_GENERATE_ENUM(ENUM, STR)   ENUM,
#define SX_GENERATE_STRING(ENUM, STR) STR,

/**
 * FDB get filtering types
 */
#define FOREACH_FDB_UC_MAC_ENTRY_TYPE(F)                                                                   \
    F(SX_FDB_UC_STATIC = SFD_POLICY_STATIC,           "")                                                  \
    F(SX_FDB_UC_REMOTE = SFD_POLICY_DYNAMIC_REMOTE,   "")                                                  \
    F(SX_FDB_UC_AGEABLE = SFD_POLICY_DYNAMIC_AGEABLE, "")                                                  \
    F(SX_FDB_UC_ALL,                                  "") /**< Valid only in sx_api_fdb_uc_mac_addr_get */ \
    F(SX_FDB_UC_AGED,                                 "") /**< Valid only in sx_api_fdb_uc_mac_addr_get */ \
    F(SX_FDB_UC_NONAGED,                              "") /**< Valid only in sx_api_fdb_uc_mac_addr_get */ \
    F(SX_POLICY_INVALID = SFD_POLICY_INVALID,         "") /**< Invalid = -1 */                             \
    F(SX_FDB_UC_ENTRY_TYPE_MIN = SX_FDB_UC_STATIC,    "")                                                  \
    F(SX_FDB_UC_ENTRY_TYPE_MAX = SX_FDB_UC_AGEABLE,   "")

typedef enum sx_fdb_uc_mac_entry_type {
    FOREACH_FDB_UC_MAC_ENTRY_TYPE(SX_GENERATE_ENUM)
} sx_fdb_uc_mac_entry_type_t;

/**
 * FDB get action types
 */
#define FOREACH_FDB_ACTION(F)                                                                     \
    F(SX_FDB_ACTION_FORWARD = SFD_ACTION_FORWARD_ONLY,                   "")                      \
    F(SX_FDB_ACTION_TRAP = SFD_ACTION_TRAP_ONLY,                         "")                      \
    F(SX_FDB_ACTION_MIRROR_TO_CPU = SFD_ACTION_FORWARD_AND_TRAP,         "")                      \
    F(SX_FDB_ACTION_FORWARD_TO_ROUTER = SFD_ACTION_FORWARD_TO_IP_ROUTER, "")                      \
    F(SX_FDB_ACTION_DISCARD = SFD_ACTION_DISCARD,                        "")                      \
    F(SX_FDB_ACTION_INVALID = SFD_ACTION_INVALID,                        "") /**< Invalid = -1 */ \
    F(SX_FDB_ACTION_MIN = SX_FDB_ACTION_FORWARD,                         "")                      \
    F(SX_FDB_ACTION_MAX = SX_FDB_ACTION_DISCARD,                         "")

typedef enum sx_fdb_action {
    FOREACH_FDB_ACTION(SX_GENERATE_ENUM)
} sx_fdb_action_t;

/**
 * FDB MAC address destination type
 */
#define FOREACH_FDB_UC_MAC_ADDR_DEST_TYPE_E(F)                                                                                                                                  \
    F(SX_FDB_UC_MAC_ADDR_DEST_TYPE_LOGICAL_PORT = 0,                                           "") /**< Destination MAC is on logical port */                                   \
    F(SX_FDB_UC_MAC_ADDR_DEST_TYPE_NEXT_HOP,                                                   "") /**< Destination MAC is on remote tenant through tunnel */                   \
    F(SX_FDB_UC_MAC_ADDR_DEST_TYPE_ECMP_NEXT_HOP_CONTAINER,                                    "") /**< Destination MAC is on remote tenant that can be reached through ECMP */ \
    F(SX_FDB_UC_MAC_ADDR_DEST_TYPE_MIN = SX_FDB_UC_MAC_ADDR_DEST_TYPE_LOGICAL_PORT,            "")                                                                              \
    F(SX_FDB_UC_MAC_ADDR_DEST_TYPE_MAX = SX_FDB_UC_MAC_ADDR_DEST_TYPE_ECMP_NEXT_HOP_CONTAINER, "")

typedef enum sx_fdb_uc_mac_addr_dest_type {
    FOREACH_FDB_UC_MAC_ADDR_DEST_TYPE_E(SX_GENERATE_ENUM)
} sx_fdb_uc_mac_addr_dest_type_e;

typedef union sx_fdb_uc_mac_addr_params_dest {
    sx_next_hop_t next_hop; /**< Next Hop */
    sx_ecmp_id_t  ecmp;     /**< ECMP */
} sx_fdb_uc_mac_addr_params_dest_t;

/**
 * FDB get/set record structure
 */
typedef struct sx_fdb_uc_mac_addr_params {
    sx_fid_t                         fid_vid;    /**< Filtering Identifier, VID for static MAC */
    sx_mac_addr_t                    mac_addr;   /**< MAC address */
    sx_port_id_t                     log_port;   /**< Logical port */
    sx_fdb_uc_mac_entry_type_t       entry_type; /**< FDB Entry Type */
    sx_fdb_action_t                  action;     /**< FDB action */
    sx_fdb_uc_mac_addr_dest_type_e   dest_type;  /**< Destination type */
    sx_fdb_uc_mac_addr_params_dest_t dest;       /**< Only valid if dest_type is not SX_FDB_UC_MAC_ADDR_DEST_TYPE_LOGICAL_PORT */
} sx_fdb_uc_mac_addr_params_t;


#endif /* SX_FDB_AUTO_H */
