/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_FLOW_COUNTER_AUTO_H__
#define __SX_FLOW_COUNTER_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_flow_counter.adb file.
 * ------------------------------------------------------------------------
 */

#define SX_FLOW_COUNTER_ID_INVALID ((sx_flow_counter_id_t)0) /**< Define invalid flow counter ID */

/**
 * Flow counter ID
 */
typedef uint32_t sx_flow_counter_id_t;

/**
 * Filter for sx_api_flow_counter_iter_get
 */
typedef uint32_t sx_flow_counter_filter_t;

/**
 * Flow counter value
 */
typedef uint64_t sx_flow_counter_val_t;


/** Enum specific MACRO */
#define SX_GENERATE_ENUM(ENUM, STR)   ENUM,
#define SX_GENERATE_STRING(ENUM, STR) STR,

/**
 * Describes to which entity the flow_counter is bound to
 */
#define FOREACH_FLOW_COUNTER_BRIDGE_TYPE(F)                                          \
    F(SX_FLOW_COUNTER_INVALID_TYPE = 0, "") /**< Flow counter not bound */           \
    F(SX_FLOW_COUNTER_BRIDGE_TYPE = 1,  "") /**< Flow counter bound to the bridge */ \
    F(SX_FLOW_COUNTER_VPORT_TYPE = 2,   "") /**< Flow counter bound to the vport */

typedef enum {
    FOREACH_FLOW_COUNTER_BRIDGE_TYPE(SX_GENERATE_ENUM)
} sx_flow_counter_bridge_type_t;

/**
 * Type is used to note counter type used in create flow counter
 */
#define FOREACH_FLOW_COUNTER_TYPE(F)                                                                           \
    F(SX_FLOW_COUNTER_TYPE_BYTES = 0,                                    "") /**< Bytes counter */             \
    F(SX_FLOW_COUNTER_TYPE_PACKETS = 1,                                  "") /**< Packets counter */           \
    F(SX_FLOW_COUNTER_TYPE_PACKETS_AND_BYTES = 2,                        "") /**< Packets and bytes counter */ \
    F(SX_FLOW_COUNTER_TYPE_MIN = SX_FLOW_COUNTER_TYPE_BYTES,             "")                                   \
    F(SX_FLOW_COUNTER_TYPE_MAX = SX_FLOW_COUNTER_TYPE_PACKETS_AND_BYTES, "")

typedef enum {
    FOREACH_FLOW_COUNTER_TYPE(SX_GENERATE_ENUM)
} sx_flow_counter_type_t;

/**
 * Type is used to note Flow Counter library init parameters
 */
typedef struct {
    uint16_t flow_counter_byte_type_min_number;
    uint16_t flow_counter_packet_type_min_number;
    uint16_t flow_counter_byte_type_max_number;
    uint16_t flow_counter_packet_type_max_number;
} sx_flow_counter_params_t;

/**
 * Flow counter set
 */
typedef struct {
    uint64_t flow_counter_packets;
    uint64_t flow_counter_bytes;
} sx_flow_counter_set_t;

typedef struct {
    sx_flow_counter_id_t          flow_counter_id;
    sx_flow_counter_bridge_type_t flow_counter_bound_entity;
} sx_flow_counter_obj_t;


#endif /* SX_FLOW_COUNTER_AUTO_H */
