/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_IP_AUTO_H__
#define __SX_IP_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_ip.adb file.
 * ------------------------------------------------------------------------
 */

#include "netinet/in.h"
#include "arpa/inet.h"
#include "complib/cl_types.h"

/** Enum specific MACRO */
#define SX_GENERATE_ENUM(ENUM, STR)   ENUM,
#define SX_GENERATE_STRING(ENUM, STR) STR,

#if 0
/**
 * sx_ip_version_t enumerated type is used to note the IP version
 */
#define FOREACH_IP_VERSION(F)                                   \
    F(SX_IP_VERSION_NONE,                          "None")      \
    F(SX_IP_VERSION_IPV4 = 1,                      "IPv4")      \
    F(SX_IP_VERSION_IPV6 = 2,                      "IPv6")      \
    F(SX_IP_VERSION_IPV4_IPV6 = 3,                 "IPv4&IPv6") \
    F(SX_IP_VERSION_MIN = SX_IP_VERSION_NONE,      "")          \
    F(SX_IP_VERSION_MAX = SX_IP_VERSION_IPV4_IPV6, "")

typedef enum sx_ip_version {
    FOREACH_IP_VERSION(SX_GENERATE_ENUM)
} sx_ip_version_t;
#endif

#define FOREACH_IP_VERSION(F)                                                             \
    F(SX_IP_VERSION_NONE, "None")                                                         \
    F(SX_IP_VERSION_IPV4 = 1, "IPv4")                                                     \
    F(SX_IP_VERSION_IPV6 = 2, "IPv6")                                                     \
    F(SX_IP_VERSION_IPV4_IPV6 = 3, "IPv4&IPv6")  /* Internal */                           \
    F(SX_IP_VERSION_IPV4_IPV6_RESTORE_VLAN = 4, "IPv4&IPv6 Restore vlan")  /* Internal */ \
    F(SX_IP_VERSION_MIN = SX_IP_VERSION_NONE, "")                                         \
    F(SX_IP_VERSION_MAX = SX_IP_VERSION_IPV4_IPV6, "")
/**
 *  * sx_ip_version_t enumerated type is used to note the IP version.
 *   */
typedef enum sx_ip_version {
    FOREACH_IP_VERSION(SX_GENERATE_ENUM)
} sx_ip_version_t;


/**
 * sx_ip_v4_addr_t structure is used to store IPv4 address.
 */
typedef struct in_addr sx_ip_v4_addr_t;

/**
 * sx_ip_v6_addr_t structure is used to store IPv6 address.
 * Note: The defined convention in SDK is that each word of s6_addr32 is in host byte-order,
 *        while the different words are ordered in network byte-order
 */
typedef struct in6_addr sx_ip_v6_addr_t;

typedef union sx_ip_addr_ver {
    sx_ip_v4_addr_t ipv4;
    sx_ip_v6_addr_t ipv6;
} sx_ip_addr_ver_t;

/**
 * sx_ip_addr_t structure is used to store IP address
 */
typedef struct sx_ip_addr {
    sx_ip_version_t  version;
    sx_ip_addr_ver_t addr;
} sx_ip_addr_t;


#endif /* SX_IP_AUTO_H */
