/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_PORT_AUTO_H__
#define __SX_PORT_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_port.adb file.
 * ------------------------------------------------------------------------
 */


/** Enum specific MACRO */
#define SX_GENERATE_ENUM(ENUM, STR)   ENUM,
#define SX_GENERATE_STRING(ENUM, STR) STR,

/**
 * Port Phy Module Power Mode
 */
#define FOREACH_MGMT_PHY_MOD_PWR_MODE_E(F)                                                                                                            \
    F(SX_MGMT_PHY_MOD_PWR_MODE_INVALID_E = 0x00,                           "PWR_MODE_INVALID") /**< When module is not present pwr mode is invalid */ \
    F(SX_MGMT_PHY_MOD_PWR_MODE_LOW_E = 0x01,                               "PWR_MODE_LOW")     /**< Low Power mode enabled */                         \
    F(SX_MGMT_PHY_MOD_PWR_MODE_HIGH_E = 0x02,                              "PWR_MODE_HIGH")    /**< High Power mode enabled, Read Only */             \
    F(SX_MGMT_PHY_MOD_PWR_MODE_AUTO_E = 0x03,                              "PWR_MODE_AUTO")    /**< Power Mode as per EEPROM */                       \
    F(SX_MGMT_PHY_MOD_PWR_MODE_MIN_E = SX_MGMT_PHY_MOD_PWR_MODE_INVALID_E, "PWR_MODE_MIN")                                                            \
    F(SX_MGMT_PHY_MOD_PWR_MODE_MAX_E = SX_MGMT_PHY_MOD_PWR_MODE_AUTO_E,    "PWR_MODE_MAX")

typedef enum sx_mgmt_phy_mod_pwr_mode {
    FOREACH_MGMT_PHY_MOD_PWR_MODE_E(SX_GENERATE_ENUM)
} sx_mgmt_phy_mod_pwr_mode_e;

/**
 * Port Phy Module Attribute type
 */
#define FOREACH_MGMT_PHY_MOD_PWR_ATTR_TYPE_E(F)                                                    \
    F(SX_MGMT_PHY_MOD_PWR_ATTR_PWR_MODE_E = 1 << 0,                           "PWR_ATTR_PWR_MODE") \
    F(SX_MGMT_PHY_MOD_PWR_ATTR_MIN_E = SX_MGMT_PHY_MOD_PWR_ATTR_PWR_MODE_E, "PWR_ATTR_MIN")        \
    F(SX_MGMT_PHY_MOD_PWR_ATTR_MAX_E = SX_MGMT_PHY_MOD_PWR_ATTR_PWR_MODE_E, "PWR_ATTR_MAX")

typedef enum sx_mgmt_phy_mod_pwr_attr_type {
    FOREACH_MGMT_PHY_MOD_PWR_ATTR_TYPE_E(SX_GENERATE_ENUM)
} sx_mgmt_phy_mod_pwr_attr_type_e;

/**
 * Port Phy Module Power Mode Attributes
 */
typedef struct sx_mgmt_phy_mod_pwr_mode_attr {
    sx_mgmt_phy_mod_pwr_mode_e admin_pwr_mode_e; /**< Admin Power mode  */
    sx_mgmt_phy_mod_pwr_mode_e oper_pwr_mode_e;  /**< Operation Power Mode */
} sx_mgmt_phy_mod_pwr_mode_attr_t;

/**
 * Port Phy Module Power Attributes
 */
typedef struct sx_mgmt_phy_mod_pwr_attr {
    uint8_t                         power_attr_type; /**< Power Attribute type */
    sx_mgmt_phy_mod_pwr_mode_attr_t pwr_mode_attr;   /**< Module Power Mode */
} sx_mgmt_phy_mod_pwr_attr_t;


#endif /* SX_PORT_AUTO_H */
