/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_PORT_ID_AUTO_H__
#define __SX_PORT_ID_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_port_id.adb file.
 * ------------------------------------------------------------------------
 */

/**
 *  ***************
 *  Logical entity, that represents the format of a virtual port or the classical
 *  format of a LAG in the GLOBAL system:
 *  *******************************************************************************************
 *  +-----------+----------------------------+----------------------------+-------------------+
 *  |Type[31:28]|      Device-ID[27:16]      | Port-Phy-ID[15:8]          | Port-Sub-ID[7:0]  |
 *  +-----------+----------------------------+----------------------------+-------------------+
 *  *******************************************************************************************
 *  +-----------+----------------------------+----------------------------+-------------------+
 *  |Type[31:28]|      Reserved[27:16]       |       LAG-ID[15:8]         | Port-Sub-ID[7:0]  |
 *  +-----------+----------------------------+----------------------------+-------------------+
 *  *******************************************************************************************
 *  +-----------+----------------------------+----------------------------+-------------------+
 *  |Type[31:28]|      Vlan-ID[27:16]        | Port-Phy-ID / LAG-ID[15:8] | Port-Sub-ID[7:0]  |
 *  +-----------+----------------------------+----------------------------+-------------------+
 *  *******************************************************************************************
 */
typedef uint32_t sx_port_log_id_t;

typedef sx_port_log_id_t sx_port_id_t;


#endif /* SX_PORT_ID_AUTO_H */
