/*
 *  Copyright (C) 2010-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SX_ROUTER_NEXT_HOP_BASE_AUTO_H__
#define __SX_ROUTER_NEXT_HOP_BASE_AUTO_H__

/*
 * [[ WARNING | AUTOMATICALLY GENERATED FILE ]]
 * ------------------------------------------------------------------------
 * This file has been generated by the script:
 *     applibs/sx_api_utils/generator/sx_header_gen.py.
 *
 * You can manually modify this file ONLY for your testing needs.
 * In all other cases manual changes in this file must be removed
 * before committing. To modify content of this file in legal way
 * use applibs/include/adb/sx_router_next_hop_base.adb file.
 * ------------------------------------------------------------------------
 */

/**
 * Router Interface ID
 */
typedef uint16_t sx_router_interface_t;

/**
 * ECMP Container ID
 */
typedef uint32_t sx_ecmp_id_t;


/** Enum specific MACRO */
#define SX_GENERATE_ENUM(ENUM, STR)   ENUM,
#define SX_GENERATE_STRING(ENUM, STR) STR,

/**
 * sx_router_action_t enumerated type is used to note the route action
 */
#define FOREACH_ROUTER_ACTION(F)                                                                                                                                                                                         \
    F(SX_ROUTER_ACTION_DROP,                                   "Drop")                                                                                                                                                   \
    F(SX_ROUTER_ACTION_TRAP,                                   "Trap")                                                                                                                                                   \
    F(SX_ROUTER_ACTION_FORWARD,                                "Forward")                                                                                                                                                \
    F(SX_ROUTER_ACTION_MIRROR,                                 "Trap and Forward") /**< /deprecated This value is deprecated and will be removed in the future. Please use SX_ROUTER_ACTION_TRAP_FORWARD in its place */ \
    F(SX_ROUTER_ACTION_TRAP_FORWARD = SX_ROUTER_ACTION_MIRROR, "")                                                                                                                                                       \
    F(SX_ROUTER_ACTION_SPAN,                                   "Span")                                                                                                                                                   \
    F(SX_ROUTER_ACTION_MIN = SX_ROUTER_ACTION_DROP,            "")                                                                                                                                                       \
    F(SX_ROUTER_ACTION_MAX = SX_ROUTER_ACTION_SPAN,            "")

typedef enum sx_router_action {
    FOREACH_ROUTER_ACTION(SX_GENERATE_ENUM)
} sx_router_action_t;

/**
 * sx_trap_attributes_t structure is used to store router trap attributes
 */
typedef struct sx_trap_attributes {
    sx_trap_priority_t prio;
} sx_trap_attributes_t;

/**
 * Next hop weight
 */
typedef uint32_t sx_next_hop_weight_t;

typedef struct sx_ip_next_hop {
    sx_ip_addr_t          address;
    sx_router_interface_t rif;
} sx_ip_next_hop_t;


#endif /* SX_ROUTER_NEXT_HOP_BASE_AUTO_H */
