/*
 *  Copyright (C) 2014-2020. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */
#ifndef __SX_FID_MANAGER_H__
#define __SX_FID_MANAGER_H__

#include "sx/sdk/auto_headers/sx_fid_manager_auto.h"


#define SX_GENERATE_ENUM(ENUM, STR) ENUM,

/**
 * sx_fm_fid_type_t is used to define type of bridge, to which
 * FID belongs
 */
#define FOREACH_FM_FID_TYPE(F)                                     \
    F(SX_FM_FID_TYPE_INVALID, "INVALID FID")                       \
    F(SX_FM_FID_TYPE_VLAN_NONREWRITE_E, "VLAN non-rewritable")     \
    F(SX_FM_FID_TYPE_VLAN_REWRITE_E, "VLAN rewritable")            \
    F(SX_FM_FID_TYPE_BRIDGE_REWRITE_E, "Bridge rewritable")        \
    F(SX_FM_FID_TYPE_RIF_E, "RIF")                                 \
    F(SX_FM_FID_TYPE_MIN_E = SX_FM_FID_TYPE_VLAN_NONREWRITE_E, "") \
    F(SX_FM_FID_TYPE_MAX_E = SX_FM_FID_TYPE_RIF_E, "")

/** Type of FID stored in FID manager */
typedef enum sx_fm_fid_type {
    FOREACH_FM_FID_TYPE(SX_GENERATE_ENUM)
} sx_fm_fid_type_t;

#define SX_FM_FID_IS_VLAN(fid_type)                    \
    ((fid_type == SX_FM_FID_TYPE_VLAN_NONREWRITE_E) || \
     (fid_type == SX_FM_FID_TYPE_VLAN_REWRITE_E))

#endif /* __SX_FID_MANAGER_H__ */
