/*
 * Copyright (C) Mellanox Technologies, Ltd. 2008-2020 ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of Mellanox Technologies, Ltd.
 * (the "Company") and all right, title, and interest in and to the software product,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */
/*
 * THIS FILE IS AUTO GENERATED.
 * DO NOT MAKE ANY CHANGES!
 * They will be erased with next update.

 */

#ifndef __SXD_EMAD_AUTO_DATA_H__
#define __SXD_EMAD_AUTO_DATA_H__

#include <sx/sxd/sxd_emad_common_data.h>
#include <sx/sxd/sxd_types.h>
#include <sx/sxd/auto_registers/reg.h>


/************************************************
 *  Local Defines
 ***********************************************/


/************************************************
 *  Local Macros
 ***********************************************/


/************************************************
 *  Local Type definitions
 ***********************************************/


/************************************************
 *  Defines
 ***********************************************/


/************************************************
 *  Macros
 ***********************************************/


/************************************************
 *  Type definitions
 ***********************************************/

/**
 * sxd_emad_icsr_data_t structure is used to store ICSR register data.
 */
typedef struct sxd_emad_icsr_data {
    sxd_emad_common_data_t   common;
    struct ku_icsr_reg      *reg_data;
} sxd_emad_icsr_data_t;

/**
 * sxd_emad_iicr_data_t structure is used to store IICR register data.
 */
typedef struct sxd_emad_iicr_data {
    sxd_emad_common_data_t   common;
    struct ku_iicr_reg      *reg_data;
} sxd_emad_iicr_data_t;

/**
 * sxd_emad_igcr_data_t structure is used to store IGCR register data.
 */
typedef struct sxd_emad_igcr_data {
    sxd_emad_common_data_t   common;
    struct ku_igcr_reg      *reg_data;
} sxd_emad_igcr_data_t;

/**
 * sxd_emad_pemrbt_data_t structure is used to store PEMRBT register data.
 */
typedef struct sxd_emad_pemrbt_data {
    sxd_emad_common_data_t   common;
    struct ku_pemrbt_reg    *reg_data;
} sxd_emad_pemrbt_data_t;

/**
 * sxd_emad_pecnee_data_t structure is used to store PECNEE register data.
 */
typedef struct sxd_emad_pecnee_data {
    sxd_emad_common_data_t   common;
    struct ku_pecnee_reg    *reg_data;
} sxd_emad_pecnee_data_t;

/**
 * sxd_emad_mtmp_data_t structure is used to store MTMP register data.
 */
typedef struct sxd_emad_mtmp_data {
    sxd_emad_common_data_t   common;
    struct ku_mtmp_reg      *reg_data;
} sxd_emad_mtmp_data_t;

/**
 * sxd_emad_tieem_data_t structure is used to store TIEEM register data.
 */
typedef struct sxd_emad_tieem_data {
    sxd_emad_common_data_t   common;
    struct ku_tieem_reg     *reg_data;
} sxd_emad_tieem_data_t;

/**
 * sxd_emad_mogcr_data_t structure is used to store MOGCR register data.
 */
typedef struct sxd_emad_mogcr_data {
    sxd_emad_common_data_t   common;
    struct ku_mogcr_reg     *reg_data;
} sxd_emad_mogcr_data_t;

/**
 * sxd_emad_rtdp_data_t structure is used to store RTDP register data.
 */
typedef struct sxd_emad_rtdp_data {
    sxd_emad_common_data_t   common;
    struct ku_rtdp_reg      *reg_data;
} sxd_emad_rtdp_data_t;

/**
 * sxd_emad_pecner_data_t structure is used to store PECNER register data.
 */
typedef struct sxd_emad_pecner_data {
    sxd_emad_common_data_t   common;
    struct ku_pecner_reg    *reg_data;
} sxd_emad_pecner_data_t;

/**
 * sxd_emad_tneem_data_t structure is used to store TNEEM register data.
 */
typedef struct sxd_emad_tneem_data {
    sxd_emad_common_data_t   common;
    struct ku_tneem_reg     *reg_data;
} sxd_emad_tneem_data_t;

/**
 * sxd_emad_tnifr_data_t structure is used to store TNIFR register data.
 */
typedef struct sxd_emad_tnifr_data {
    sxd_emad_common_data_t   common;
    struct ku_tnifr_reg     *reg_data;
} sxd_emad_tnifr_data_t;

/**
 * sxd_emad_peaps_data_t structure is used to store PEAPS register data.
 */
typedef struct sxd_emad_peaps_data {
    sxd_emad_common_data_t   common;
    struct ku_peaps_reg     *reg_data;
} sxd_emad_peaps_data_t;

/**
 * sxd_emad_hcot_data_t structure is used to store HCOT register data.
 */
typedef struct sxd_emad_hcot_data {
    sxd_emad_common_data_t   common;
    struct ku_hcot_reg      *reg_data;
} sxd_emad_hcot_data_t;

/**
 * sxd_emad_chltm_data_t structure is used to store CHLTM register data.
 */
typedef struct sxd_emad_chltm_data {
    sxd_emad_common_data_t   common;
    struct ku_chltm_reg     *reg_data;
} sxd_emad_chltm_data_t;

/**
 * sxd_emad_hmon_data_t structure is used to store HMON register data.
 */
typedef struct sxd_emad_hmon_data {
    sxd_emad_common_data_t   common;
    struct ku_hmon_reg      *reg_data;
} sxd_emad_hmon_data_t;

/**
 * sxd_emad_mgpir_data_t structure is used to store MGPIR register data.
 */
typedef struct sxd_emad_mgpir_data {
    sxd_emad_common_data_t   common;
    struct ku_mgpir_reg     *reg_data;
} sxd_emad_mgpir_data_t;

/**
 * sxd_emad_tnqdr_data_t structure is used to store TNQDR register data.
 */
typedef struct sxd_emad_tnqdr_data {
    sxd_emad_common_data_t   common;
    struct ku_tnqdr_reg     *reg_data;
} sxd_emad_tnqdr_data_t;

/**
 * sxd_emad_sffp_data_t structure is used to store SFFP register data.
 */
typedef struct sxd_emad_sffp_data {
    sxd_emad_common_data_t   common;
    struct ku_sffp_reg      *reg_data;
} sxd_emad_sffp_data_t;

/**
 * sxd_emad_mpcir_data_t structure is used to store MPCIR register data.
 */
typedef struct sxd_emad_mpcir_data {
    sxd_emad_common_data_t   common;
    struct ku_mpcir_reg     *reg_data;
} sxd_emad_mpcir_data_t;

/**
 * sxd_emad_pter_data_t structure is used to store PTER register data.
 */
typedef struct sxd_emad_pter_data {
    sxd_emad_common_data_t   common;
    struct ku_pter_reg      *reg_data;
} sxd_emad_pter_data_t;

/**
 * sxd_emad_smpu_data_t structure is used to store SMPU register data.
 */
typedef struct sxd_emad_smpu_data {
    sxd_emad_common_data_t   common;
    struct ku_smpu_reg      *reg_data;
} sxd_emad_smpu_data_t;

/**
 * sxd_emad_pmmp_data_t structure is used to store PMMP register data.
 */
typedef struct sxd_emad_pmmp_data {
    sxd_emad_common_data_t   common;
    struct ku_pmmp_reg      *reg_data;
} sxd_emad_pmmp_data_t;

/**
 * sxd_emad_pecnrr_data_t structure is used to store PECNRR register data.
 */
typedef struct sxd_emad_pecnrr_data {
    sxd_emad_common_data_t   common;
    struct ku_pecnrr_reg    *reg_data;
} sxd_emad_pecnrr_data_t;

/**
 * sxd_emad_tnpc_data_t structure is used to store TNPC register data.
 */
typedef struct sxd_emad_tnpc_data {
    sxd_emad_common_data_t   common;
    struct ku_tnpc_reg      *reg_data;
} sxd_emad_tnpc_data_t;

/**
 * sxd_emad_pecnre_data_t structure is used to store PECNRE register data.
 */
typedef struct sxd_emad_pecnre_data {
    sxd_emad_common_data_t   common;
    struct ku_pecnre_reg    *reg_data;
} sxd_emad_pecnre_data_t;

/**
 * sxd_emad_ralcm_data_t structure is used to store RALCM register data.
 */
typedef struct sxd_emad_ralcm_data {
    sxd_emad_common_data_t   common;
    struct ku_ralcm_reg     *reg_data;
} sxd_emad_ralcm_data_t;

/**
 * sxd_emad_mgir_data_t structure is used to store MGIR register data.
 */
typedef struct sxd_emad_mgir_data {
    sxd_emad_common_data_t   common;
    struct ku_mgir_reg      *reg_data;
} sxd_emad_mgir_data_t;

/**
 * sxd_emad_tidem_data_t structure is used to store TIDEM register data.
 */
typedef struct sxd_emad_tidem_data {
    sxd_emad_common_data_t   common;
    struct ku_tidem_reg     *reg_data;
} sxd_emad_tidem_data_t;

/**
 * sxd_emad_tigcr_data_t structure is used to store TIGCR register data.
 */
typedef struct sxd_emad_tigcr_data {
    sxd_emad_common_data_t   common;
    struct ku_tigcr_reg     *reg_data;
} sxd_emad_tigcr_data_t;

/**
 * sxd_emad_rlcmld_data_t structure is used to store RLCMLD register data.
 */
typedef struct sxd_emad_rlcmld_data {
    sxd_emad_common_data_t   common;
    struct ku_rlcmld_reg    *reg_data;
} sxd_emad_rlcmld_data_t;

/**
 * sxd_emad_ifbf_data_t structure is used to store IFBF register data.
 */
typedef struct sxd_emad_ifbf_data {
    sxd_emad_common_data_t   common;
    struct ku_ifbf_reg      *reg_data;
} sxd_emad_ifbf_data_t;

/**
 * sxd_emad_ibfmrc_data_t structure is used to store IBFMRC register data.
 */
typedef struct sxd_emad_ibfmrc_data {
    sxd_emad_common_data_t   common;
    struct ku_ibfmrc_reg    *reg_data;
} sxd_emad_ibfmrc_data_t;

/**
 * sxd_emad_xralta_data_t structure is used to store XRALTA register data.
 */
typedef struct sxd_emad_xralta_data {
    sxd_emad_common_data_t   common;
    struct ku_xralta_reg    *reg_data;
} sxd_emad_xralta_data_t;

/**
 * sxd_emad_mpagr_data_t structure is used to store MPAGR register data.
 */
typedef struct sxd_emad_mpagr_data {
    sxd_emad_common_data_t   common;
    struct ku_mpagr_reg     *reg_data;
} sxd_emad_mpagr_data_t;

/**
 * sxd_emad_xltq_data_t structure is used to store XLTQ register data.
 */
typedef struct sxd_emad_xltq_data {
    sxd_emad_common_data_t   common;
    struct ku_xltq_reg      *reg_data;
} sxd_emad_xltq_data_t;

/**
 * sxd_emad_ppcnt_data_t structure is used to store PPCNT register data.
 */
typedef struct sxd_emad_ppcnt_data {
    sxd_emad_common_data_t   common;
    struct ku_ppcnt_reg     *reg_data;
} sxd_emad_ppcnt_data_t;

/**
 * sxd_emad_pefaad_data_t structure is used to store PEFAAD register data.
 */
typedef struct sxd_emad_pefaad_data {
    sxd_emad_common_data_t   common;
    struct ku_pefaad_reg    *reg_data;
} sxd_emad_pefaad_data_t;

/**
 * sxd_emad_chlmm_data_t structure is used to store CHLMM register data.
 */
typedef struct sxd_emad_chlmm_data {
    sxd_emad_common_data_t   common;
    struct ku_chlmm_reg     *reg_data;
} sxd_emad_chlmm_data_t;

/**
 * sxd_emad_tncr_data_t structure is used to store TNCR register data.
 */
typedef struct sxd_emad_tncr_data {
    sxd_emad_common_data_t   common;
    struct ku_tncr_reg      *reg_data;
} sxd_emad_tncr_data_t;

/**
 * sxd_emad_xmdr_data_t structure is used to store XMDR register data.
 */
typedef struct sxd_emad_xmdr_data {
    sxd_emad_common_data_t   common;
    struct ku_xmdr_reg      *reg_data;
} sxd_emad_xmdr_data_t;

/**
 * sxd_emad_mdfcr_data_t structure is used to store MDFCR register data.
 */
typedef struct sxd_emad_mdfcr_data {
    sxd_emad_common_data_t   common;
    struct ku_mdfcr_reg     *reg_data;
} sxd_emad_mdfcr_data_t;

/**
 * sxd_emad_paos_data_t structure is used to store PAOS register data.
 */
typedef struct sxd_emad_paos_data {
    sxd_emad_common_data_t   common;
    struct ku_paos_reg      *reg_data;
} sxd_emad_paos_data_t;

/**
 * sxd_emad_mtutc_data_t structure is used to store MTUTC register data.
 */
typedef struct sxd_emad_mtutc_data {
    sxd_emad_common_data_t   common;
    struct ku_mtutc_reg     *reg_data;
} sxd_emad_mtutc_data_t;

/**
 * sxd_emad_sfmr_data_t structure is used to store SFMR register data.
 */
typedef struct sxd_emad_sfmr_data {
    sxd_emad_common_data_t   common;
    struct ku_sfmr_reg      *reg_data;
} sxd_emad_sfmr_data_t;

/**
 * sxd_emad_smpe_data_t structure is used to store SMPE register data.
 */
typedef struct sxd_emad_smpe_data {
    sxd_emad_common_data_t   common;
    struct ku_smpe_reg      *reg_data;
} sxd_emad_smpe_data_t;

/**
 * sxd_emad_tiqdr_data_t structure is used to store TIQDR register data.
 */
typedef struct sxd_emad_tiqdr_data {
    sxd_emad_common_data_t   common;
    struct ku_tiqdr_reg     *reg_data;
} sxd_emad_tiqdr_data_t;

/**
 * sxd_emad_xraltb_data_t structure is used to store XRALTB register data.
 */
typedef struct sxd_emad_xraltb_data {
    sxd_emad_common_data_t   common;
    struct ku_xraltb_reg    *reg_data;
} sxd_emad_xraltb_data_t;

/**
 * sxd_emad_tngee_data_t structure is used to store TNGEE register data.
 */
typedef struct sxd_emad_tngee_data {
    sxd_emad_common_data_t   common;
    struct ku_tngee_reg     *reg_data;
} sxd_emad_tngee_data_t;

/**
 * sxd_emad_smpeb_data_t structure is used to store SMPEB register data.
 */
typedef struct sxd_emad_smpeb_data {
    sxd_emad_common_data_t   common;
    struct ku_smpeb_reg     *reg_data;
} sxd_emad_smpeb_data_t;

/**
 * sxd_emad_ibfmr_data_t structure is used to store IBFMR register data.
 */
typedef struct sxd_emad_ibfmr_data {
    sxd_emad_common_data_t   common;
    struct ku_ibfmr_reg     *reg_data;
} sxd_emad_ibfmr_data_t;

/**
 * sxd_emad_ppbs_data_t structure is used to store PPBS register data.
 */
typedef struct sxd_emad_ppbs_data {
    sxd_emad_common_data_t   common;
    struct ku_ppbs_reg      *reg_data;
} sxd_emad_ppbs_data_t;

/**
 * sxd_emad_xlkbu_data_t structure is used to store XLKBU register data.
 */
typedef struct sxd_emad_xlkbu_data {
    sxd_emad_common_data_t   common;
    struct ku_xlkbu_reg     *reg_data;
} sxd_emad_xlkbu_data_t;

/**
 * sxd_emad_xrmt_data_t structure is used to store XRMT register data.
 */
typedef struct sxd_emad_xrmt_data {
    sxd_emad_common_data_t   common;
    struct ku_xrmt_reg      *reg_data;
} sxd_emad_xrmt_data_t;

/**
 * sxd_emad_reiv_data_t structure is used to store REIV register data.
 */
typedef struct sxd_emad_reiv_data {
    sxd_emad_common_data_t   common;
    struct ku_reiv_reg      *reg_data;
} sxd_emad_reiv_data_t;

/**
 * sxd_emad_ppad_data_t structure is used to store PPAD register data.
 */
typedef struct sxd_emad_ppad_data {
    sxd_emad_common_data_t   common;
    struct ku_ppad_reg      *reg_data;
} sxd_emad_ppad_data_t;

/**
 * sxd_emad_rlcmle_data_t structure is used to store RLCMLE register data.
 */
typedef struct sxd_emad_rlcmle_data {
    sxd_emad_common_data_t   common;
    struct ku_rlcmle_reg    *reg_data;
} sxd_emad_rlcmle_data_t;

/**
 * sxd_emad_mcqi_data_t structure is used to store MCQI register data.
 */
typedef struct sxd_emad_mcqi_data {
    sxd_emad_common_data_t   common;
    struct ku_mcqi_reg      *reg_data;
} sxd_emad_mcqi_data_t;

/**
 * sxd_emad_chltr_data_t structure is used to store CHLTR register data.
 */
typedef struct sxd_emad_chltr_data {
    sxd_emad_common_data_t   common;
    struct ku_chltr_reg     *reg_data;
} sxd_emad_chltr_data_t;

/**
 * sxd_emad_tngcr_data_t structure is used to store TNGCR register data.
 */
typedef struct sxd_emad_tngcr_data {
    sxd_emad_common_data_t   common;
    struct ku_tngcr_reg     *reg_data;
} sxd_emad_tngcr_data_t;

/**
 * sxd_emad_rips_data_t structure is used to store RIPS register data.
 */
typedef struct sxd_emad_rips_data {
    sxd_emad_common_data_t   common;
    struct ku_rips_reg      *reg_data;
} sxd_emad_rips_data_t;

/**
 * sxd_emad_tndem_data_t structure is used to store TNDEM register data.
 */
typedef struct sxd_emad_tndem_data {
    sxd_emad_common_data_t   common;
    struct ku_tndem_reg     *reg_data;
} sxd_emad_tndem_data_t;

/**
 * sxd_emad_tnumt_data_t structure is used to store TNUMT register data.
 */
typedef struct sxd_emad_tnumt_data {
    sxd_emad_common_data_t   common;
    struct ku_tnumt_reg     *reg_data;
} sxd_emad_tnumt_data_t;

/**
 * sxd_emad_rlcme_data_t structure is used to store RLCME register data.
 */
typedef struct sxd_emad_rlcme_data {
    sxd_emad_common_data_t   common;
    struct ku_rlcme_reg     *reg_data;
} sxd_emad_rlcme_data_t;

/**
 * sxd_emad_pevpb_data_t structure is used to store PEVPB register data.
 */
typedef struct sxd_emad_pevpb_data {
    sxd_emad_common_data_t   common;
    struct ku_pevpb_reg     *reg_data;
} sxd_emad_pevpb_data_t;

/**
 * sxd_emad_sfgc_data_t structure is used to store SFGC register data.
 */
typedef struct sxd_emad_sfgc_data {
    sxd_emad_common_data_t   common;
    struct ku_sfgc_reg      *reg_data;
} sxd_emad_sfgc_data_t;

/**
 * sxd_emad_mcion_data_t structure is used to store MCION register data.
 */
typedef struct sxd_emad_mcion_data {
    sxd_emad_common_data_t   common;
    struct ku_mcion_reg     *reg_data;
} sxd_emad_mcion_data_t;

/**
 * sxd_emad_tiqcr_data_t structure is used to store TIQCR register data.
 */
typedef struct sxd_emad_tiqcr_data {
    sxd_emad_common_data_t   common;
    struct ku_tiqcr_reg     *reg_data;
} sxd_emad_tiqcr_data_t;

/**
 * sxd_emad_tncr_v2_data_t structure is used to store TNCR_V2 register data.
 */
typedef struct sxd_emad_tncr_v2_data {
    sxd_emad_common_data_t   common;
    struct ku_tncr_v2_reg   *reg_data;
} sxd_emad_tncr_v2_data_t;

/**
 * sxd_emad_xralst_data_t structure is used to store XRALST register data.
 */
typedef struct sxd_emad_xralst_data {
    sxd_emad_common_data_t   common;
    struct ku_xralst_reg    *reg_data;
} sxd_emad_xralst_data_t;

/**
 * sxd_emad_iddd_data_t structure is used to store IDDD register data.
 */
typedef struct sxd_emad_iddd_data {
    sxd_emad_common_data_t   common;
    struct ku_iddd_reg      *reg_data;
} sxd_emad_iddd_data_t;

/**
 * sxd_emad_iedr_data_t structure is used to store IEDR register data.
 */
typedef struct sxd_emad_iedr_data {
    sxd_emad_common_data_t   common;
    struct ku_iedr_reg      *reg_data;
} sxd_emad_iedr_data_t;

/**
 * sxd_emad_ieds_data_t structure is used to store IEDS register data.
 */
typedef struct sxd_emad_ieds_data {
    sxd_emad_common_data_t   common;
    struct ku_ieds_reg      *reg_data;
} sxd_emad_ieds_data_t;

/**
 * sxd_emad_pmaos_data_t structure is used to store PMAOS register data.
 */
typedef struct sxd_emad_pmaos_data {
    sxd_emad_common_data_t   common;
    struct ku_pmaos_reg     *reg_data;
} sxd_emad_pmaos_data_t;

/**
 * sxd_emad_rxlte_data_t structure is used to store RXLTE register data.
 */
typedef struct sxd_emad_rxlte_data {
    sxd_emad_common_data_t   common;
    struct ku_rxlte_reg     *reg_data;
} sxd_emad_rxlte_data_t;

/**
 * sxd_emad_sbhbr_v2_data_t structure is used to store SBHBR_V2 register data.
 */
typedef struct sxd_emad_sbhbr_v2_data {
    sxd_emad_common_data_t   common;
    struct ku_sbhbr_v2_reg  *reg_data;
} sxd_emad_sbhbr_v2_data_t;

/**
 * sxd_emad_tnqcr_data_t structure is used to store TNQCR register data.
 */
typedef struct sxd_emad_tnqcr_data {
    sxd_emad_common_data_t   common;
    struct ku_tnqcr_reg     *reg_data;
} sxd_emad_tnqcr_data_t;

/**
 * sxd_emad_sbhrr_v2_data_t structure is used to store SBHRR_V2 register data.
 */
typedef struct sxd_emad_sbhrr_v2_data {
    sxd_emad_common_data_t   common;
    struct ku_sbhrr_v2_reg  *reg_data;
} sxd_emad_sbhrr_v2_data_t;

/**
 * sxd_emad_rxltm_data_t structure is used to store RXLTM register data.
 */
typedef struct sxd_emad_rxltm_data {
    sxd_emad_common_data_t   common;
    struct ku_rxltm_reg     *reg_data;
} sxd_emad_rxltm_data_t;

/**
 * sxd_emad_momte_data_t structure is used to store MOMTE register data.
 */
typedef struct sxd_emad_momte_data {
    sxd_emad_common_data_t   common;
    struct ku_momte_reg     *reg_data;
} sxd_emad_momte_data_t;

/**
 * sxd_emad_rmpe_data_t structure is used to store RMPE register data.
 */
typedef struct sxd_emad_rmpe_data {
    sxd_emad_common_data_t   common;
    struct ku_rmpe_reg      *reg_data;
} sxd_emad_rmpe_data_t;

/**
 * sxd_emad_svfa_data_t structure is used to store SVFA register data.
 */
typedef struct sxd_emad_svfa_data {
    sxd_emad_common_data_t   common;
    struct ku_svfa_reg      *reg_data;
} sxd_emad_svfa_data_t;

/**
 * sxd_emad_mcc_data_t structure is used to store MCC register data.
 */
typedef struct sxd_emad_mcc_data {
    sxd_emad_common_data_t   common;
    struct ku_mcc_reg       *reg_data;
} sxd_emad_mcc_data_t;

/**
 * sxd_emad_sfdb_data_t structure is used to store SFDB register data.
 */
typedef struct sxd_emad_sfdb_data {
    sxd_emad_common_data_t   common;
    struct ku_sfdb_reg      *reg_data;
} sxd_emad_sfdb_data_t;

/**
 * sxd_emad_pmtps_data_t structure is used to store PMTPS register data.
 */
typedef struct sxd_emad_pmtps_data {
    sxd_emad_common_data_t   common;
    struct ku_pmtps_reg     *reg_data;
} sxd_emad_pmtps_data_t;

/**
 * sxd_emad_rxltcc_data_t structure is used to store RXLTCC register data.
 */
typedef struct sxd_emad_rxltcc_data {
    sxd_emad_common_data_t   common;
    struct ku_rxltcc_reg    *reg_data;
} sxd_emad_rxltcc_data_t;

/**
 * sxd_emad_mcda_data_t structure is used to store MCDA register data.
 */
typedef struct sxd_emad_mcda_data {
    sxd_emad_common_data_t   common;
    struct ku_mcda_reg      *reg_data;
} sxd_emad_mcda_data_t;


/************************************************
 *  Global variables
 ***********************************************/


/************************************************
 *  Function declarations
 ***********************************************/



#endif /* __SXD_EMAD_AUTO_DATA_H__ */
