/*
 * Copyright (C) Mellanox Technologies, Ltd. 2008-2020 ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of Mellanox Technologies, Ltd.
 * (the "Company") and all right, title, and interest in and to the software product,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */
/*
 * THIS FILE IS AUTO GENERATED.
 * DO NOT MAKE ANY CHANGES!
 * They will be erased with next update.

 */

#ifndef __SXD_EMAD_AUTO_REG_H__
#define __SXD_EMAD_AUTO_REG_H__


#include <sx/sxd/sxd_types.h>
#include <sx/sxd/auto_registers/reg.h>

#include <complib/cl_packon.h>
/************************************************
 *  Local Defines
 ***********************************************/


/************************************************
 *  Local Macros
 ***********************************************/


/************************************************
 *  Local Type definitions
 ***********************************************/


/************************************************
 *  Defines
 ***********************************************/


/************************************************
 *  Macros
 ***********************************************/


/************************************************
 *  Type definitions
 ***********************************************/

/**
 * sxd_emad_icsr_reg_t structure is used to store ICSR register layout.
 */
typedef struct sxd_emad_icsr_reg {
    char reg[MLXSW_ICSR_LEN];
} PACK_SUFFIX sxd_emad_icsr_reg_t;

/**
 * sxd_emad_iicr_reg_t structure is used to store IICR register layout.
 */
typedef struct sxd_emad_iicr_reg {
    char reg[MLXSW_IICR_LEN];
} PACK_SUFFIX sxd_emad_iicr_reg_t;

/**
 * sxd_emad_igcr_reg_t structure is used to store IGCR register layout.
 */
typedef struct sxd_emad_igcr_reg {
    char reg[MLXSW_IGCR_LEN];
} PACK_SUFFIX sxd_emad_igcr_reg_t;

/**
 * sxd_emad_pemrbt_reg_t structure is used to store PEMRBT register layout.
 */
typedef struct sxd_emad_pemrbt_reg {
    char reg[MLXSW_PEMRBT_LEN];
} PACK_SUFFIX sxd_emad_pemrbt_reg_t;

/**
 * sxd_emad_pecnee_reg_t structure is used to store PECNEE register layout.
 */
typedef struct sxd_emad_pecnee_reg {
    char reg[MLXSW_PECNEE_LEN];
} PACK_SUFFIX sxd_emad_pecnee_reg_t;

/**
 * sxd_emad_mtmp_reg_t structure is used to store MTMP register layout.
 */
typedef struct sxd_emad_mtmp_reg {
    char reg[MLXSW_MTMP_LEN];
} PACK_SUFFIX sxd_emad_mtmp_reg_t;

/**
 * sxd_emad_tieem_reg_t structure is used to store TIEEM register layout.
 */
typedef struct sxd_emad_tieem_reg {
    char reg[MLXSW_TIEEM_LEN];
} PACK_SUFFIX sxd_emad_tieem_reg_t;

/**
 * sxd_emad_mogcr_reg_t structure is used to store MOGCR register layout.
 */
typedef struct sxd_emad_mogcr_reg {
    char reg[MLXSW_MOGCR_LEN];
} PACK_SUFFIX sxd_emad_mogcr_reg_t;

/**
 * sxd_emad_rtdp_reg_t structure is used to store RTDP register layout.
 */
typedef struct sxd_emad_rtdp_reg {
    char reg[MLXSW_RTDP_LEN];
} PACK_SUFFIX sxd_emad_rtdp_reg_t;

/**
 * sxd_emad_pecner_reg_t structure is used to store PECNER register layout.
 */
typedef struct sxd_emad_pecner_reg {
    char reg[MLXSW_PECNER_LEN];
} PACK_SUFFIX sxd_emad_pecner_reg_t;

/**
 * sxd_emad_tneem_reg_t structure is used to store TNEEM register layout.
 */
typedef struct sxd_emad_tneem_reg {
    char reg[MLXSW_TNEEM_LEN];
} PACK_SUFFIX sxd_emad_tneem_reg_t;

/**
 * sxd_emad_tnifr_reg_t structure is used to store TNIFR register layout.
 */
typedef struct sxd_emad_tnifr_reg {
    char reg[MLXSW_TNIFR_LEN];
} PACK_SUFFIX sxd_emad_tnifr_reg_t;

/**
 * sxd_emad_peaps_reg_t structure is used to store PEAPS register layout.
 */
typedef struct sxd_emad_peaps_reg {
    char reg[MLXSW_PEAPS_LEN];
} PACK_SUFFIX sxd_emad_peaps_reg_t;

/**
 * sxd_emad_hcot_reg_t structure is used to store HCOT register layout.
 */
typedef struct sxd_emad_hcot_reg {
    char reg[MLXSW_HCOT_LEN];
} PACK_SUFFIX sxd_emad_hcot_reg_t;

/**
 * sxd_emad_chltm_reg_t structure is used to store CHLTM register layout.
 */
typedef struct sxd_emad_chltm_reg {
    char reg[MLXSW_CHLTM_LEN];
} PACK_SUFFIX sxd_emad_chltm_reg_t;

/**
 * sxd_emad_hmon_reg_t structure is used to store HMON register layout.
 */
typedef struct sxd_emad_hmon_reg {
    char reg[MLXSW_HMON_LEN];
} PACK_SUFFIX sxd_emad_hmon_reg_t;

/**
 * sxd_emad_mgpir_reg_t structure is used to store MGPIR register layout.
 */
typedef struct sxd_emad_mgpir_reg {
    char reg[MLXSW_MGPIR_LEN];
} PACK_SUFFIX sxd_emad_mgpir_reg_t;

/**
 * sxd_emad_tnqdr_reg_t structure is used to store TNQDR register layout.
 */
typedef struct sxd_emad_tnqdr_reg {
    char reg[MLXSW_TNQDR_LEN];
} PACK_SUFFIX sxd_emad_tnqdr_reg_t;

/**
 * sxd_emad_sffp_reg_t structure is used to store SFFP register layout.
 */
typedef struct sxd_emad_sffp_reg {
    char reg[MLXSW_SFFP_LEN];
} PACK_SUFFIX sxd_emad_sffp_reg_t;

/**
 * sxd_emad_mpcir_reg_t structure is used to store MPCIR register layout.
 */
typedef struct sxd_emad_mpcir_reg {
    char reg[MLXSW_MPCIR_LEN];
} PACK_SUFFIX sxd_emad_mpcir_reg_t;

/**
 * sxd_emad_pter_reg_t structure is used to store PTER register layout.
 */
typedef struct sxd_emad_pter_reg {
    char reg[MLXSW_PTER_LEN];
} PACK_SUFFIX sxd_emad_pter_reg_t;

/**
 * sxd_emad_smpu_reg_t structure is used to store SMPU register layout.
 */
typedef struct sxd_emad_smpu_reg {
    char reg[MLXSW_SMPU_LEN];
} PACK_SUFFIX sxd_emad_smpu_reg_t;

/**
 * sxd_emad_pmmp_reg_t structure is used to store PMMP register layout.
 */
typedef struct sxd_emad_pmmp_reg {
    char reg[MLXSW_PMMP_LEN];
} PACK_SUFFIX sxd_emad_pmmp_reg_t;

/**
 * sxd_emad_pecnrr_reg_t structure is used to store PECNRR register layout.
 */
typedef struct sxd_emad_pecnrr_reg {
    char reg[MLXSW_PECNRR_LEN];
} PACK_SUFFIX sxd_emad_pecnrr_reg_t;

/**
 * sxd_emad_tnpc_reg_t structure is used to store TNPC register layout.
 */
typedef struct sxd_emad_tnpc_reg {
    char reg[MLXSW_TNPC_LEN];
} PACK_SUFFIX sxd_emad_tnpc_reg_t;

/**
 * sxd_emad_pecnre_reg_t structure is used to store PECNRE register layout.
 */
typedef struct sxd_emad_pecnre_reg {
    char reg[MLXSW_PECNRE_LEN];
} PACK_SUFFIX sxd_emad_pecnre_reg_t;

/**
 * sxd_emad_ralcm_reg_t structure is used to store RALCM register layout.
 */
typedef struct sxd_emad_ralcm_reg {
    char reg[MLXSW_RALCM_LEN];
} PACK_SUFFIX sxd_emad_ralcm_reg_t;

/**
 * sxd_emad_mgir_reg_t structure is used to store MGIR register layout.
 */
typedef struct sxd_emad_mgir_reg {
    char reg[MLXSW_MGIR_LEN];
} PACK_SUFFIX sxd_emad_mgir_reg_t;

/**
 * sxd_emad_tidem_reg_t structure is used to store TIDEM register layout.
 */
typedef struct sxd_emad_tidem_reg {
    char reg[MLXSW_TIDEM_LEN];
} PACK_SUFFIX sxd_emad_tidem_reg_t;

/**
 * sxd_emad_tigcr_reg_t structure is used to store TIGCR register layout.
 */
typedef struct sxd_emad_tigcr_reg {
    char reg[MLXSW_TIGCR_LEN];
} PACK_SUFFIX sxd_emad_tigcr_reg_t;

/**
 * sxd_emad_rlcmld_reg_t structure is used to store RLCMLD register layout.
 */
typedef struct sxd_emad_rlcmld_reg {
    char reg[MLXSW_RLCMLD_LEN];
} PACK_SUFFIX sxd_emad_rlcmld_reg_t;

/**
 * sxd_emad_ifbf_reg_t structure is used to store IFBF register layout.
 */
typedef struct sxd_emad_ifbf_reg {
    char reg[MLXSW_IFBF_LEN];
} PACK_SUFFIX sxd_emad_ifbf_reg_t;

/**
 * sxd_emad_ibfmrc_reg_t structure is used to store IBFMRC register layout.
 */
typedef struct sxd_emad_ibfmrc_reg {
    char reg[MLXSW_IBFMRC_LEN];
} PACK_SUFFIX sxd_emad_ibfmrc_reg_t;

/**
 * sxd_emad_xralta_reg_t structure is used to store XRALTA register layout.
 */
typedef struct sxd_emad_xralta_reg {
    char reg[MLXSW_XRALTA_LEN];
} PACK_SUFFIX sxd_emad_xralta_reg_t;

/**
 * sxd_emad_mpagr_reg_t structure is used to store MPAGR register layout.
 */
typedef struct sxd_emad_mpagr_reg {
    char reg[MLXSW_MPAGR_LEN];
} PACK_SUFFIX sxd_emad_mpagr_reg_t;

/**
 * sxd_emad_xltq_reg_t structure is used to store XLTQ register layout.
 */
typedef struct sxd_emad_xltq_reg {
    char reg[MLXSW_XLTQ_LEN];
} PACK_SUFFIX sxd_emad_xltq_reg_t;

/**
 * sxd_emad_ppcnt_reg_t structure is used to store PPCNT register layout.
 */
typedef struct sxd_emad_ppcnt_reg {
    char reg[MLXSW_PPCNT_LEN];
} PACK_SUFFIX sxd_emad_ppcnt_reg_t;

/**
 * sxd_emad_pefaad_reg_t structure is used to store PEFAAD register layout.
 */
typedef struct sxd_emad_pefaad_reg {
    char reg[MLXSW_PEFAAD_LEN];
} PACK_SUFFIX sxd_emad_pefaad_reg_t;

/**
 * sxd_emad_chlmm_reg_t structure is used to store CHLMM register layout.
 */
typedef struct sxd_emad_chlmm_reg {
    char reg[MLXSW_CHLMM_LEN];
} PACK_SUFFIX sxd_emad_chlmm_reg_t;

/**
 * sxd_emad_tncr_reg_t structure is used to store TNCR register layout.
 */
typedef struct sxd_emad_tncr_reg {
    char reg[MLXSW_TNCR_LEN];
} PACK_SUFFIX sxd_emad_tncr_reg_t;

/**
 * sxd_emad_xmdr_reg_t structure is used to store XMDR register layout.
 */
typedef struct sxd_emad_xmdr_reg {
    char reg[MLXSW_XMDR_LEN];
} PACK_SUFFIX sxd_emad_xmdr_reg_t;

/**
 * sxd_emad_mdfcr_reg_t structure is used to store MDFCR register layout.
 */
typedef struct sxd_emad_mdfcr_reg {
    char reg[MLXSW_MDFCR_LEN];
} PACK_SUFFIX sxd_emad_mdfcr_reg_t;

/**
 * sxd_emad_paos_reg_t structure is used to store PAOS register layout.
 */
typedef struct sxd_emad_paos_reg {
    char reg[MLXSW_PAOS_LEN];
} PACK_SUFFIX sxd_emad_paos_reg_t;

/**
 * sxd_emad_mtutc_reg_t structure is used to store MTUTC register layout.
 */
typedef struct sxd_emad_mtutc_reg {
    char reg[MLXSW_MTUTC_LEN];
} PACK_SUFFIX sxd_emad_mtutc_reg_t;

/**
 * sxd_emad_sfmr_reg_t structure is used to store SFMR register layout.
 */
typedef struct sxd_emad_sfmr_reg {
    char reg[MLXSW_SFMR_LEN];
} PACK_SUFFIX sxd_emad_sfmr_reg_t;

/**
 * sxd_emad_smpe_reg_t structure is used to store SMPE register layout.
 */
typedef struct sxd_emad_smpe_reg {
    char reg[MLXSW_SMPE_LEN];
} PACK_SUFFIX sxd_emad_smpe_reg_t;

/**
 * sxd_emad_tiqdr_reg_t structure is used to store TIQDR register layout.
 */
typedef struct sxd_emad_tiqdr_reg {
    char reg[MLXSW_TIQDR_LEN];
} PACK_SUFFIX sxd_emad_tiqdr_reg_t;

/**
 * sxd_emad_xraltb_reg_t structure is used to store XRALTB register layout.
 */
typedef struct sxd_emad_xraltb_reg {
    char reg[MLXSW_XRALTB_LEN];
} PACK_SUFFIX sxd_emad_xraltb_reg_t;

/**
 * sxd_emad_tngee_reg_t structure is used to store TNGEE register layout.
 */
typedef struct sxd_emad_tngee_reg {
    char reg[MLXSW_TNGEE_LEN];
} PACK_SUFFIX sxd_emad_tngee_reg_t;

/**
 * sxd_emad_smpeb_reg_t structure is used to store SMPEB register layout.
 */
typedef struct sxd_emad_smpeb_reg {
    char reg[MLXSW_SMPEB_LEN];
} PACK_SUFFIX sxd_emad_smpeb_reg_t;

/**
 * sxd_emad_ibfmr_reg_t structure is used to store IBFMR register layout.
 */
typedef struct sxd_emad_ibfmr_reg {
    char reg[MLXSW_IBFMR_LEN];
} PACK_SUFFIX sxd_emad_ibfmr_reg_t;

/**
 * sxd_emad_ppbs_reg_t structure is used to store PPBS register layout.
 */
typedef struct sxd_emad_ppbs_reg {
    char reg[MLXSW_PPBS_LEN];
} PACK_SUFFIX sxd_emad_ppbs_reg_t;

/**
 * sxd_emad_xlkbu_reg_t structure is used to store XLKBU register layout.
 */
typedef struct sxd_emad_xlkbu_reg {
    char reg[MLXSW_XLKBU_LEN];
} PACK_SUFFIX sxd_emad_xlkbu_reg_t;

/**
 * sxd_emad_xrmt_reg_t structure is used to store XRMT register layout.
 */
typedef struct sxd_emad_xrmt_reg {
    char reg[MLXSW_XRMT_LEN];
} PACK_SUFFIX sxd_emad_xrmt_reg_t;

/**
 * sxd_emad_reiv_reg_t structure is used to store REIV register layout.
 */
typedef struct sxd_emad_reiv_reg {
    char reg[MLXSW_REIV_LEN];
} PACK_SUFFIX sxd_emad_reiv_reg_t;

/**
 * sxd_emad_ppad_reg_t structure is used to store PPAD register layout.
 */
typedef struct sxd_emad_ppad_reg {
    char reg[MLXSW_PPAD_LEN];
} PACK_SUFFIX sxd_emad_ppad_reg_t;

/**
 * sxd_emad_rlcmle_reg_t structure is used to store RLCMLE register layout.
 */
typedef struct sxd_emad_rlcmle_reg {
    char reg[MLXSW_RLCMLE_LEN];
} PACK_SUFFIX sxd_emad_rlcmle_reg_t;

/**
 * sxd_emad_mcqi_reg_t structure is used to store MCQI register layout.
 */
typedef struct sxd_emad_mcqi_reg {
    char reg[MLXSW_MCQI_LEN];
} PACK_SUFFIX sxd_emad_mcqi_reg_t;

/**
 * sxd_emad_chltr_reg_t structure is used to store CHLTR register layout.
 */
typedef struct sxd_emad_chltr_reg {
    char reg[MLXSW_CHLTR_LEN];
} PACK_SUFFIX sxd_emad_chltr_reg_t;

/**
 * sxd_emad_tngcr_reg_t structure is used to store TNGCR register layout.
 */
typedef struct sxd_emad_tngcr_reg {
    char reg[MLXSW_TNGCR_LEN];
} PACK_SUFFIX sxd_emad_tngcr_reg_t;

/**
 * sxd_emad_rips_reg_t structure is used to store RIPS register layout.
 */
typedef struct sxd_emad_rips_reg {
    char reg[MLXSW_RIPS_LEN];
} PACK_SUFFIX sxd_emad_rips_reg_t;

/**
 * sxd_emad_tndem_reg_t structure is used to store TNDEM register layout.
 */
typedef struct sxd_emad_tndem_reg {
    char reg[MLXSW_TNDEM_LEN];
} PACK_SUFFIX sxd_emad_tndem_reg_t;

/**
 * sxd_emad_tnumt_reg_t structure is used to store TNUMT register layout.
 */
typedef struct sxd_emad_tnumt_reg {
    char reg[MLXSW_TNUMT_LEN];
} PACK_SUFFIX sxd_emad_tnumt_reg_t;

/**
 * sxd_emad_rlcme_reg_t structure is used to store RLCME register layout.
 */
typedef struct sxd_emad_rlcme_reg {
    char reg[MLXSW_RLCME_LEN];
} PACK_SUFFIX sxd_emad_rlcme_reg_t;

/**
 * sxd_emad_pevpb_reg_t structure is used to store PEVPB register layout.
 */
typedef struct sxd_emad_pevpb_reg {
    char reg[MLXSW_PEVPB_LEN];
} PACK_SUFFIX sxd_emad_pevpb_reg_t;

/**
 * sxd_emad_sfgc_reg_t structure is used to store SFGC register layout.
 */
typedef struct sxd_emad_sfgc_reg {
    char reg[MLXSW_SFGC_LEN];
} PACK_SUFFIX sxd_emad_sfgc_reg_t;

/**
 * sxd_emad_mcion_reg_t structure is used to store MCION register layout.
 */
typedef struct sxd_emad_mcion_reg {
    char reg[MLXSW_MCION_LEN];
} PACK_SUFFIX sxd_emad_mcion_reg_t;

/**
 * sxd_emad_tiqcr_reg_t structure is used to store TIQCR register layout.
 */
typedef struct sxd_emad_tiqcr_reg {
    char reg[MLXSW_TIQCR_LEN];
} PACK_SUFFIX sxd_emad_tiqcr_reg_t;

/**
 * sxd_emad_tncr_v2_reg_t structure is used to store TNCR_V2 register layout.
 */
typedef struct sxd_emad_tncr_v2_reg {
    char reg[MLXSW_TNCR_V2_LEN];
} PACK_SUFFIX sxd_emad_tncr_v2_reg_t;

/**
 * sxd_emad_xralst_reg_t structure is used to store XRALST register layout.
 */
typedef struct sxd_emad_xralst_reg {
    char reg[MLXSW_XRALST_LEN];
} PACK_SUFFIX sxd_emad_xralst_reg_t;

/**
 * sxd_emad_iddd_reg_t structure is used to store IDDD register layout.
 */
typedef struct sxd_emad_iddd_reg {
    char reg[MLXSW_IDDD_LEN];
} PACK_SUFFIX sxd_emad_iddd_reg_t;

/**
 * sxd_emad_iedr_reg_t structure is used to store IEDR register layout.
 */
typedef struct sxd_emad_iedr_reg {
    char reg[MLXSW_IEDR_LEN];
} PACK_SUFFIX sxd_emad_iedr_reg_t;

/**
 * sxd_emad_ieds_reg_t structure is used to store IEDS register layout.
 */
typedef struct sxd_emad_ieds_reg {
    char reg[MLXSW_IEDS_LEN];
} PACK_SUFFIX sxd_emad_ieds_reg_t;

/**
 * sxd_emad_pmaos_reg_t structure is used to store PMAOS register layout.
 */
typedef struct sxd_emad_pmaos_reg {
    char reg[MLXSW_PMAOS_LEN];
} PACK_SUFFIX sxd_emad_pmaos_reg_t;

/**
 * sxd_emad_rxlte_reg_t structure is used to store RXLTE register layout.
 */
typedef struct sxd_emad_rxlte_reg {
    char reg[MLXSW_RXLTE_LEN];
} PACK_SUFFIX sxd_emad_rxlte_reg_t;

/**
 * sxd_emad_sbhbr_v2_reg_t structure is used to store SBHBR_V2 register layout.
 */
typedef struct sxd_emad_sbhbr_v2_reg {
    char reg[MLXSW_SBHBR_V2_LEN];
} PACK_SUFFIX sxd_emad_sbhbr_v2_reg_t;

/**
 * sxd_emad_tnqcr_reg_t structure is used to store TNQCR register layout.
 */
typedef struct sxd_emad_tnqcr_reg {
    char reg[MLXSW_TNQCR_LEN];
} PACK_SUFFIX sxd_emad_tnqcr_reg_t;

/**
 * sxd_emad_sbhrr_v2_reg_t structure is used to store SBHRR_V2 register layout.
 */
typedef struct sxd_emad_sbhrr_v2_reg {
    char reg[MLXSW_SBHRR_V2_LEN];
} PACK_SUFFIX sxd_emad_sbhrr_v2_reg_t;

/**
 * sxd_emad_rxltm_reg_t structure is used to store RXLTM register layout.
 */
typedef struct sxd_emad_rxltm_reg {
    char reg[MLXSW_RXLTM_LEN];
} PACK_SUFFIX sxd_emad_rxltm_reg_t;

/**
 * sxd_emad_momte_reg_t structure is used to store MOMTE register layout.
 */
typedef struct sxd_emad_momte_reg {
    char reg[MLXSW_MOMTE_LEN];
} PACK_SUFFIX sxd_emad_momte_reg_t;

/**
 * sxd_emad_rmpe_reg_t structure is used to store RMPE register layout.
 */
typedef struct sxd_emad_rmpe_reg {
    char reg[MLXSW_RMPE_LEN];
} PACK_SUFFIX sxd_emad_rmpe_reg_t;

/**
 * sxd_emad_svfa_reg_t structure is used to store SVFA register layout.
 */
typedef struct sxd_emad_svfa_reg {
    char reg[MLXSW_SVFA_LEN];
} PACK_SUFFIX sxd_emad_svfa_reg_t;

/**
 * sxd_emad_mcc_reg_t structure is used to store MCC register layout.
 */
typedef struct sxd_emad_mcc_reg {
    char reg[MLXSW_MCC_LEN];
} PACK_SUFFIX sxd_emad_mcc_reg_t;

/**
 * sxd_emad_sfdb_reg_t structure is used to store SFDB register layout.
 */
typedef struct sxd_emad_sfdb_reg {
    char reg[MLXSW_SFDB_LEN];
} PACK_SUFFIX sxd_emad_sfdb_reg_t;

/**
 * sxd_emad_pmtps_reg_t structure is used to store PMTPS register layout.
 */
typedef struct sxd_emad_pmtps_reg {
    char reg[MLXSW_PMTPS_LEN];
} PACK_SUFFIX sxd_emad_pmtps_reg_t;

/**
 * sxd_emad_rxltcc_reg_t structure is used to store RXLTCC register layout.
 */
typedef struct sxd_emad_rxltcc_reg {
    char reg[MLXSW_RXLTCC_LEN];
} PACK_SUFFIX sxd_emad_rxltcc_reg_t;

/**
 * sxd_emad_mcda_reg_t structure is used to store MCDA register layout.
 */
typedef struct sxd_emad_mcda_reg {
    char reg[MLXSW_MCDA_LEN];
} PACK_SUFFIX sxd_emad_mcda_reg_t;


/************************************************
 *  Global variables
 ***********************************************/


/************************************************
 *  Function declarations
 ***********************************************/

#include <complib/cl_packoff.h>

#endif /* __SXD_EMAD_AUTO_REG_H__ */
